**ONE2MAN.PRG
**PURPOSE -- One to Many Browsing using multiple databases
**CREDITS -- Rick Spence's "Browsing Multiple Databases" from Clipper Programming Guide, 2nd Ed.
**Chapter 7, Pg 341+ and previous points
**Anyone who uses 5.0 should get this book as required reading.
**DATE -- Feb. 18, 1991
**COMPILE.  Clipper one2man -m. LINK. Rtlink FI one2man
**COMMENTS --I wish I could say I wrote this but I wouldn't be a banker if I had !
**I did put together the code samples to make this work. Mr. Spence's ideas
**go fast and all of the ideas are not consolidated. Some things were left out.
**This illustrates a one-to-many relationship using INVOICES.DBF, a set
**of invoices from a software retailer and DETAILS.DBF, the items each
**customer purchased. Conveniently each customer bought an entire software
**type ! There are only five main invoice records. <Enter> shows the current record
**<Esc> ends the program. See the book for details and comments on the code.
**.Prg consists of a main routine plus three functions -- GOTOTOP,GOTOBOTT
**and MOVEPOINTER which handle the movements. These are great examples of
**black box functions that can be reused over and over again.
**If anything this small program shows the power and untapped potential of
**Clipper 5. Try this in Summer 1987 in less than 200 lines !
**OK, Nantucket, Now what about a MEMO or TEXT class to go along with TBROWSE ?
**I would like to have a MEMOEDIT with a 64K limitation !
**Ben Y. Hicks, Fredericksburg, Va.

#include "inkey.ch"
#include "dbstruct.ch"
#include "setcurs.ch"

#define INS_CURSOR iif(readinsert(), SC_INSERT, SC_NORMAL)
#define COMPILE(c_exp) &("{||" + c_exp+"}")
#define DEF_HSEP chr(205)+chr(209)+chr(205)
#define DEF_FSEP chr(205)+chr(207)+chr(205)
#define DEF_CSEP "  "
#define BROWSE_EDIT_ALL(tb) aeval(dbstruct(),;
                 {|f_stru|;
                 tb:addcolumn(tbcolumnnew(f_stru[DBS_NAME], ;
                 fieldblock(f_stru[DBS_NAME])))})

Clear
Use Details new
INDEX ON INV_NUM TO Details
Use invoices new
INDEX on INV_NUM to invoices
i_key_cb=COMPILE(indexkey())

SET RELATION TO inv_num INTO Details

** Each window can have its own object. Each object can have its own vars.
@0,0 to 11,79
inv_browser=tbrowsedb(1,1,10,78)
inv_browser:headsep=DEF_HSEP
inv_browser:colsep=DEF_CSEP
inv_browser:footsep=DEF_FSEP

BROWSE_EDIT_ALL(inv_browser)

@12,0 to 24,79
det_browser=tbrowsedb(13,1,23,78)
det_browser:headsep=DEF_HSEP
det_browser:colsep=DEF_CSEP
det_browser:footsep=DEF_FSEP

det_searcher=invoices->inv_num
det_browser:gobottomblock={||gotobott(det_searcher)}
det_browser:gotopblock={||gototop(det_searcher)}
det_browser:skipblock={|n|movepointer(n,det_searcher,i_key_cb)}

SELECT details
BROWSE_EDIT_ALL(det_browser)
det_browser:getcolumn(1):block={|| iif(eof(), "No Match", inv_num)}

SELECT invoices
exit_requested=.F.
set cursor off
det_browser:cargo=0

** The meat is below**

Do While !exit_requested

    Do While nextkey()=0.and.!inv_browser:stabilize()
    enddo

    If nextkey()=0.and.recno()!=det_browser:cargo
        det_browser:cargo=invoices->(recno())
        SELECT details
        det_browser:refreshall()
        det_searcher=invoices->inv_num
        DO WHILE !det_browser:stabilize()
        ENDDO
        det_browser:dehilite()
        SELECT invoices
   Endif
        nkey=inkey(0)

       DO CASE
      CASE ( nKey == K_DOWN )
         inv_browser:down()
      CASE ( nKey == K_UP )
         inv_browser:up()
      CASE ( nKey == K_PGDN )
         inv_browser:pageDown()
      CASE ( nKey == K_PGUP )
         inv_browser:pageUp()
      CASE ( nKey == K_CTRL_PGUP )
         inv_browser:goTop()
      CASE ( nKey == K_CTRL_PGDN )
         inv_browser:goBottom()
      CASE ( nKey == K_RIGHT )
         inv_browser:right()
      CASE ( nKey == K_LEFT )
         inv_browser:left()
      CASE ( nKey == K_HOME )
         inv_browser:home()
      CASE ( nKey == K_END )
         inv_browser:end()
      CASE ( nKey == K_CTRL_LEFT )
         inv_browser:panLeft()
      CASE ( nKey == K_CTRL_RIGHT )
         inv_browser:panRight()
      CASE ( nKey == K_CTRL_HOME )
         inv_browser:panHome()
      CASE ( nKey == K_CTRL_END )
         inv_browser:panEnd()
      CASE ( nKey == K_ESC )
         exit_requested=.T.
      CASE ( nKey == K_RETURN )
         set color to +B/W
         ret_scr=SAVESCREEN(11,25,13,57)
         @11,26 CLEAR to 13,56
         @11,26 to 13,56
         @12,27 SAY "YOU PRESSED RETURN AT "
         @12,50 SAY INV_NUM
         INKEY(0)
         set color to +N/W
         RESTSCREEN(11,25,13,57,ret_Scr)
      ENDCASE

Enddo
Clear
set cursor on
Close all

*****
* FUNCTION GOTOTOP
*
FUNCTION gototop(searcher)
SEEK searcher
Return NIL

****
* FUNCTION GOTOBOTT
*
FUNCTION gotobott(searcher)
LOCAL save_soft:=set(_SET_SOFTSEEK,.T.)
Seek substr(searcher,1,len(searcher)-1)+Chr(asc(substr(searcher,len(searcher)))+1)
Skip -1
set(_SET_SOFTSEEK,save_soft)
Return NINL

*****
* FUNCTION MOVEPOINTER
*
FUNCTION Movepointer(num_to_skip,searcher,i_key_cb)
LOCAL num_skipped:=0

    If num_to_skip=0
      Skip 0
    Else
        Do While !eof().AND. !bof();
           .AND. num_skipped !=num_to_skip;
           .AND. eval(i_key_cb)= searcher

            If num_to_skip>0
               SKIP
               num_skipped++
            Else
               SKIP-1
               num_skipped--
            Endif
        ENDDO

        If EOF()
           SKIP -1
           num_skipped--
           ELSEIF bof()
           num_skipped++
           ELSEIF eval(i_key_cb) !=searcher
                If num_to_skip>0
                SKIP -1
                num_skipped--
                ELSE
                SKIP
                num_skipped++
                ENDIF
         ENDIF
   ENDIF

RETURN num_skipped
